package org.um.feri.spin_msc_generator.msc_parameters;

public class MSCCommentParameters {

	/**
	 * 
	 * MSCCommentParameters is one of a org.um.feri.spin_msc_generator_msc_parameters package in which we define
	 * description of Comment which appears in MSC document. 
	 * 
	 * */
	
	private String cifStartText	= "";
	private final String cifEndText		= "/* CIF End Text */";
	private String comment = "";
	
	/**
	 * 
	 * MSCCommentParameters is a constructor which accepts width of a MSC, comment width and text.
	 * It needs MSC width which describes where MSC comment should be placed. Text is a comment which is entered
	 * by user.
	 * 
	 * */
	
	public MSCCommentParameters(int _mscWidth, int _commentWidth, String _comment){
		this.comment = _comment;
		
		int startComment = _mscWidth - _commentWidth;
		
		cifStartText	= "  /* CIF TEXT (" + startComment +", " + 40 + ") (400, 300) */";
	}
	
	/**
	 * 
	 * Method getComment returns textual representation of what should be returned to a MSCCommentParameters
	 * parent.
	 * 
	 * 
	 * */
	
	public StringBuffer getComment(){
		StringBuffer str = new StringBuffer();
		
		str.append(cifStartText + "\n");
		str.append("  /*");
		
		str.append(processComment(comment) + "\n");
		
		str.append("  */" + "\n");
		str.append("  "+cifEndText);
		
		return str;
	}
		
	/**
	 * 
	 * Method processComment splits comment to multiple lines that it fits in Comment area.
	 * @param _comment in one line
	 * @return comment comment in multiple lines
	 * 
	 * 
	 * */
	
	private StringBuffer processComment(String _comment){
		String tmpComment	= "";
		StringBuffer str	= new StringBuffer();
		String[] tokens = _comment.split(" ");
		int charCounter = 0;
		
		for (int i=0; i<tokens.length; i++){
			charCounter = charCounter + tokens[i].length();
			
			if (charCounter >= 28){
				str = str.append("\n" + tmpComment);
				tmpComment = "    " + tokens[i];
				charCounter = tokens[i].length() + 1;
			}
			else {
				if (tmpComment.length() == 0){
					tmpComment = "    " + tokens[i];
				}
				else {
					tmpComment = tmpComment + " " + tokens[i];				
				}
				charCounter = charCounter + 1;
			}
		}
		
		if (tmpComment.length() != 0){
			str = str.append("\n" + tmpComment);
		}
		
		return str;	
	}
}
