package org.um.feri.spin_msc_generator.msc_parameters;

public class MSCMessageParameters {
	
	/**
	 * 
	 * Class which offers description of MSC Message construct.
	 * 
	 * 
	 * */
	
	
	private String cifMessage	= "";
	private String message		= "";
	
	/**
	 * 
	 * @param first_par which tells if message was sent or received (OUT, IN)
	 * @param second_par which tells if message was sent or received (TO, FROM)
	 * @param name name of message
	 * @param value value of message
	 * @param start_x starting X coordinate
	 * @parm start_y starting Y coordinate
	 * @param end_x ending X coordinate
	 * @param end_y ending Y coordinate
	 * @param show_parameters variable tells if parameters should be shown
	 * 
	 * 
	 * */
	
	public MSCMessageParameters(String first_par, String second_par, String name, String value, 
			int start_x, int start_y, int end_x, int end_y, boolean show_parameters, boolean environment, String toFrom){
		cifMessage	= "    /* CIF MESSAGE (" + start_x + ", " + start_y + ") (" + end_x + ", " + end_y + ")*/";
		if (!show_parameters){
			message		= "    " + first_par + " " + name + "(" + value + ") "+ second_par + " " + toFrom;
			if (environment){
				message = message + " ENV;";
			}
			else {
				message = message + ";";
			}
		}
		else {
			message		= "    " + first_par + " " + name + " " + second_par + " " + toFrom;
			if (environment){
				message = message + " ENV;";
			}
			else {
				message = message + ";";
			}
		}
	}
	
	/**
	 * 
	 * Returns CIF compliant version of message
	 * @return message in CIF format ready to output in file
	 * 
	 * */
	
	public String getCifMessage(){
		return cifMessage;		
	}
	
	/**
	 * 
	 * Method returns message
	 * 
	 * */
	public String getMessage(){
		return message;
	}
}
