package org.um.feri.spin_msc_generator.process;

/**
 * 
 * MSCProcess class
 * 
 * @author Tim KOVSE - UM FERI
 * 
 * @version 1.0
 * 
 *    
 * */

public class MSCProcess {

	/**
	 * 
	 * MSCProcess class is a class for storing informations parsed from Spin trail out file. His main variables
	 * are ID of process, process Name, parent ID of current process and line in which the process was created
	 * 
	 * */
	
	
	private String	procID; 		// ID of process
	private String	procName; 		// Name of process
	private String	parentID;		// ID of parent process
	private String	parentName;		// Name of process parent
	private int		processLineID;	// ID of line where process is created
	
	/**
	 * 
	 * MSCProcess constructor for storing informations about new process
	 * 
	 * */
		
	public MSCProcess(String _procID, String _procName, String _parentID, String _parentName, int _processLineID){
		this.procID			= _procID;
		this.procName		= _procName;
		this.parentID		= _parentID;
		this.parentName		= _parentName;
		this.processLineID	= _processLineID;
	}
	
	/**
	 * 
	 * Method returns ID of process
	 * 
	 * */
	
	public String	getProcID()	{
		return this.procID;
	}
	
	/**
	 * 
	 * Method returns process name
	 * 
	 * */
	
	public String 	getProcName() { 
		return this.procName;
	}
	
	/**
	 * 
	 * Method returns parent ID
	 * 
	 * */
	
	public String 	getParentID() {
		return this.parentID;
	}
	
	/**
	 * 
	 * Method returns parent name
	 * 
	 * */
	
	public String 	getParentName() {
		return this.parentName;
	}
	
	/**
	 * 
	 * Method returns ID of line in which process was detected
	 * 
	 * */
	
	public int 	getProcessLineID() {
		return this.processLineID;
	}
}
