package org.um.feri.spin_msc_generator.process;

public class MSCVirtualProcess {
	
	/**
	 * 
	 * MSCVirtualProcess class is class for storing temporary 'tables' of objects (processes) which were
	 * combined by user.
	 * 
	 * <i>
	 * Example:
	 * 
	 * ActualID	AcutalName	NewID	NewName
	 * 1		proxy1		1		proxy		
	 * 2		proxy2		1		proxy
	 * 3		proxy3		1		proxy
	 * 
	 * This table shows, that three processes (proxy1, proxy2, proxy3) were combined into one process called proxy.
	 * ID of new process is the same as the ID of first process (proxy1) 
	 * </i>
	 *  
	 * */
	
	
	private String actualID = "";
	private String actualName = "";
	
	private String newID = "";
	private String newName = "";
		
	/**
	 * 
	 * MSCVirtualProcess constructor is defined for setting a new instance of virtual process
	 * 
	 * @param _actualID ID of actual process
	 * @param _actualName name of actual process
	 * @param _newID ID of newly created process
	 * @param _newName name of newly created process
	 * 
	 * */
	
	MSCVirtualProcess(String _actualID, String _actualName, String _newID, String _newName){
		this.actualID = _actualID;
		this.actualName = _actualName;
		
		this.newID = _newID;
		this.newName = _newName;
	}
	
	/**
	 * 
	 * Method returns actual ID of process
	 * 
	 * */
	
	public String getActualID(){
		return this.actualID;
	}
	
	
	/**
	 * 
	 * Method returns actual name of process
	 * 
	 * */
	
	public String getActualName(){
		return this.actualName;
	}
	
	/**
	 * 
	 * Method returns new ID of virtual process
	 * 
	 * */
	
	public String getNewID(){
		return this.newID;
	}
	
	/**
	 * 
	 * Method returns new Name of virtual process
	 * 
	 * */
	
	public String getNewName(){
		return this.newName;
	}
}
